//Verilog HDL for "ID_CEPC", "ID_ChipTriggerLogic" "functional"


module ID_ChipTriggerLogic (clk, G_rst, datain, dataout, trgstmp, trglatency, read_req, read_ack, enable, trigger_en,error,match, realtrgstmp);
input clk;
input G_rst;
input enable;
input trigger_en;
input signed [31:0]datain;
output signed [31:0]dataout;
input signed [7:0]trglatency;
input signed [7:0]trgstmp;
input signed [7:0]error;
output signed [7:0]realtrgstmp;
input read_req;
output read_ack;
output match;

reg read_ack;
reg [31:0]trgdata;
reg match;
reg [31:0]trglessdata;

always@(negedge clk or posedge G_rst)
begin
	if(G_rst)
	begin
		trglessdata<=0;
	end
	else
	begin
		trglessdata<=datain;
	end
end

//assign dataout=(trigger_en)?trgdata:trglessdata;
assign dataout=trglessdata;


always @(negedge clk or posedge G_rst)
begin
	if(G_rst)
	begin
		read_ack<=0;
	end
	else if(trigger_en)
	begin
		if(enable)
		begin
			if(read_req)
			begin
				read_ack<=~read_ack;
			end
			else if(read_ack)
			begin
				read_ack<=0;
			end
		end
	end
	else
	begin
		if(read_req)
		begin
			read_ack<=~read_ack;
		end
		else if(read_ack)
		begin
			read_ack<=0;
		end
	end
end

wire [7:0]instmp;
assign instmp=datain[7:0];
assign realtrgstmp=trgstmp-trglatency;


always @(negedge clk or posedge G_rst)
begin
	if(G_rst)
	begin
		trgdata<=0;
		match<=0;
	end
	else if(trigger_en)
	begin
		if(~read_ack)
		begin
			if((realtrgstmp-instmp <= error) && (instmp-realtrgstmp <= error))
			begin
				trgdata<=datain;
				match<=1;
			end
			else
			begin
				match<=0;
			end
		end
	end
end

endmodule
