//Verilog HDL for "ID_CEPC", "ID_ColumnPrio" "functional"


module ID_ColumnPrio (last_busy, next_busy, read_req, read_ack, read_row, G_rst );
input last_busy;
input read_req;
input G_rst;
input read_row;
output next_busy;
output read_ack;

assign next_busy=read_req | last_busy;

reg readint;
assign read_ack=readint & read_row;

always @(G_rst or read_row)
begin
	if(G_rst)
	begin
		readint<=0;
	end
	else
	begin
		if(read_row)
		begin
			if(!last_busy & read_req)	//priority mask
			begin
				readint<=1;
			end
			else
			begin
				readint<=0;
			end
		end
	end
end

endmodule
