//Verilog HDL for "ID_CEPC", "ID_ColumnTriggerLogic" "functional"


module ID_ColumnTriggerLogic (clk, G_rst, datain, dataout, realtrgstmp, read_req, read_ack, enable, trigger_en,error,flag);
input clk;
input G_rst;
input enable;
input trigger_en;
input signed [23:0]datain;
output signed [23:0]dataout;
input signed [7:0]realtrgstmp;
input signed [7:0]error;
input read_req;
output read_ack;
output flag;

reg read_ack;
reg [23:0]trgdata;
reg flag;

assign dataout=(trigger_en)?trgdata:datain;

always @(posedge clk or posedge G_rst)
begin
	if(G_rst)
	begin
		read_ack<=0;
	end
	else if(trigger_en)
	begin
		if(enable)
		begin
			if(read_req)
			begin
				read_ack<=~read_ack;
			end
			else if(read_ack)
			begin
				read_ack<=0;
			end
		end
	end
	else
	begin
		if(read_req)
		begin
			read_ack<=~read_ack;
		end
		else if(read_ack)
		begin
			read_ack<=0;
		end
	end
end

wire [7:0]instmp;
assign instmp=datain[7:0];


always @(negedge clk or posedge G_rst)
begin
	if(G_rst)
	begin
		trgdata<=0;
		flag<=0;
	end
	else if(trigger_en)
	begin
		if(~read_ack)
		begin
			if((realtrgstmp-instmp <= error) && (instmp-realtrgstmp <= error))
			begin
				trgdata<=datain;
				flag<=1;
			end
			else
			begin
				flag<=0;
			end
		end
	end
end

endmodule
