//Verilog HDL for "ID_CEPC", "ID_PixelPrio" "functional"


module ID_PixelPrio (last_hit, next_hit, discri, rst_o, read, readint, G_rst );
input last_hit;
input discri;
input read;
input G_rst;
output next_hit;
output rst_o;
output readint;

reg hit;
wire rst;
assign next_hit=hit | last_hit;
assign rst_o=rst;

always @(discri or rst)
begin
	if(rst)
	begin
		hit<=0;
	end
	else	
	begin
		if(discri)
		begin
			hit<=1;
		end
	end
end

reg readint;
assign rst=G_rst | (readint & read);

always @(G_rst or read)
begin
	if(G_rst)
	begin
		readint<=0;
	end
	else
	begin
		if(read)
		begin
			if(!last_hit & hit)	//priority mask
			begin
				readint<=1;
			end
			else
			begin
				readint<=0;
			end
		end
	end
end

endmodule
