//Verilog HDL for "ID_CEPC", "ID_RowController" "functional"

module ID_RowController (clk,rstb,busy,read );
input clk;
input rstb;
input busy;
output read;

reg read_pre;
reg read_last;
reg prelatch;

//assign read=read_pre | read_last;
assign read=read_pre;

always@(posedge clk or negedge rstb)
begin
	if(!rstb)
	begin
		read_pre<=0;
		read_last<=0;
		prelatch<=0;
	end
	else
	begin
		if(busy)
		begin
			prelatch<=1;
		end
		else
		begin
			prelatch<=0;
		end

		if(prelatch)
		begin
			if(!read_pre)
			begin
				read_pre<=1;
			end
			else
			begin
				read_pre<=0;
			end			
		end
		
	end
end

always@(negedge clk)
begin
	if(read_pre)
	begin
		read_last<=1;
	end
	else
	begin
		read_last<=0;
	end
end

endmodule
