//Verilog HDL for "ID_CEPC", "ID_RowController_delay" "functional"


module ID_RowController_delay (clk,rstb,busy,freeze,read );
input clk;
input rstb;
input busy;
output freeze;
output read;

reg freeze;
reg prelatch;
reg read_pre;
reg read_last;

//assign read=read_pre | read_last;
assign read=read_pre;

always@(posedge clk or negedge rstb)
begin
	if(!rstb)
	begin
		freeze<=0;
		prelatch<=0;
		read_pre<=0;
		read_last<=0;
	end
	else
	begin
		if(busy)
		begin
			prelatch<=1;
		end
		else
		begin
			prelatch<=0;
			freeze<=0;
		end
		
		if(prelatch & busy)
		begin
			freeze<=1;
		end
		else
		begin
			freeze<=0;
		end
		
		if(freeze)
		begin
			if(!read_pre)
			begin
				read_pre<=1;
			end
			else
			begin
				read_pre<=0;
			end			
		end
		else
		begin
			read_pre<=0;
		end
		
	end
end

always@(negedge clk)
begin
	if(read_pre)
	begin
		read_last<=1;
	end
	else
	begin
		read_last<=0;
	end
end

endmodule
